(function(scope){

  var Randomized;

  scope = scope || this;

  Randomized = function(collection, indexName) {
    var cursur = 0,
        yieldOrder = [],
        collectionSize = 0,
        hasIndexMethod;

    collection = collection || {};
    hasIndexMethod = typeof collection[indexName] === "function";


    return {

      init : function(size) {
        collectionSize = size;
        cursur = 0;
        for (var i = 0; i < size; i++) {
          yieldOrder[i] = i;
        }
        yieldOrder.sort(function() { return 0.5 - Math.random();});
      },

      at : function(n) {
        if (hasIndexMethod) {
          return collection[indexName](yieldOrder[n]);
        } else {
          return yieldOrder[n];
        }
      },

      next : function(epilogue) {
        var r = this.at(cursur);
        cursur += 1;
        if (cursur === collectionSize) { 
          cursur = 0;
          if (typeof epilogue === "function") { epilogue(); }
        }
        return r;
      },

      prev : function(callback) {
        console.log(cursur);
        cursur = (cursur + collectionSize -1) % collectionSize;
        console.log(cursur);
        if (cursur === 0) {
          if (typeof callback === "function") { callback(); }
        }
        return this.at(cursur);
      }
    };

  };
  
  scope.Randomized = Randomized;

})(); 
